#ifndef __GameObject_h__
#define __GameObject_h__

#include <iostream>
#include <vector>

#include "SDL.h"
#include "Vector2D.h"

class GameObject
{
public:

  virtual void load(int x, int y, int width, int height, std::string textureID);
  virtual void load(int x, int y, int width, int height);
  virtual void draw(SDL_Renderer* pRenderer);
  virtual void update();
  virtual void clean();
  void setActive(bool state) {
	  m_active = state;
  }
  bool isActive() {
	  return m_active;
  }

  Vector2D& getPosition() {
	m_position.setX(m_x);
	m_position.setY(m_y);
	  return m_position;
  }
  int getWidth() {
	  return m_width;
  }
  int getHeight() {
 	  return m_height;
   }

protected:

  std::string m_textureID;

  int m_currentFrame;
  int m_currentRow;

  int m_x;
  int m_y;

  int m_width;
  int m_height;

	int m_destWidth;
	int m_destHeight;
	bool m_active;

 Vector2D m_position;


  std::vector<GameObject*> m_gameObjects;
};

#endif
